/*	HI_MAIL, the companion mail reading program
	to the menu program HI.	(c)1987 Nik habermel
*/
#include <stdio.h>
#include <dos.h>
#include <string.h>
#include <errno.h>
#include <assert.h>
#include <stddef.h>
#include <stdlib.h>

struct _usr {
	char name[36];
	char city[36];
	int date[20];
	char pwd[16];
	int times;
	int help;
	int tabs;
	int nulls;
	int msg;
	int more;
	int priv;
	char ldate[20];
	int time;
	unsigned flag;
	unsigned upld;
	unsigned dnld;
	unsigned dnldl;
	int files;
	char width;
	char len;
	int credit;
	int debit;
} usr;


struct _msg 
{
	char from[36];
	char to[36];
	char subj[72];
	char date[20];
	int times;
	int dest;
	int orig;
	int cost;
	int caca[6];
	unsigned reply;
	int attr;
	int up;
	char content[4096];
} msg;

   char retmsghdr1[]="Addressee ";
   char retmsghdr2[]=" not known!\nPlease re-enter mail but CHECK the "
			"usernames with the U option on the main menu\n"
			"******* Message returned as follows:\n";
			
   char msgbuffer[4091];
   char userfile[127];
   char mailfile[12];
   char badname[36];
   char me[127];

void main(int, char*[]);

void main(argc, argv)
int argc;
char *argv[];
{
   int i;
   char *c, *cme;
   struct find_t ft;

   FILE *ufp, *mfp;

   strcpy(userfile,"\\fido\\user.bbs");
   strcpy(me,"Mailer Daemon");
   cme=me;

   for(i=1; i<argc; i++) {
	if (*(c=argv[i])=='-') strcpy(userfile,++c);
	else {
		if (me!=cme) {
			assert((*cme)=='\0');
			*cme=' ';
			*(++cme)='\0';
			}
		cme+=strlen(strcpy(cme,c));
		}
	}
   me[35]='\0';

   if (!(ufp=fopen(userfile,"rb"))) {
	printf("Error: %s not found\n",userfile);
	exit(1);
	}
   fclose(ufp);
   
   _dos_findfirst("*.MSG",(unsigned) 0, &ft);
   while (errno!=ENOENT) {
	mfp=fopen(ft.name,"rb");
	fread((void *)&msg,sizeof(msg),1,mfp);
	fclose(mfp);
	
	ufp=fopen(userfile,"rb");
	usr.name[0]='\0';

	while ((!feof(ufp)) && (strcmp(msg.to,usr.name))) {
		fread((void *)&usr,sizeof(usr),1,ufp);
		}
	fclose(ufp);
	if (strcmp(msg.to,usr.name)) {
		printf("-mail to \"%s\" returned to sender\n",msg.to);
		strcpy(badname,msg.to);
		strcpy(msg.to,msg.from);
		strcpy(msg.from,me);
		msg.content[4095-
			strlen(retmsghdr1)-strlen(retmsghdr2)
			-strlen(badname)]='\0';
		strcpy(msgbuffer,msg.content);
		strcpy(msg.content,retmsghdr1);
		strcpy(msg.content+strlen(msg.content),badname);
		strcpy(msg.content+strlen(msg.content),retmsghdr2);
		strcpy(msg.content+strlen(msg.content),msgbuffer);

		/*unlink(ft.name)*/
		if (mfp=fopen(ft.name,"wb")) {
			fwrite((void *)&msg,sizeof(msg),1,mfp);
			fclose(mfp);
			}
		else printf("Cannot reopen %s for write!\n",ft.name);
		}

	ft.name[0]='\0';
	_dos_findnext(&ft);
	}
   exit(0);
}
